<template>
  <!-- 货架 -->
  <a-select
    show-search
    label-in-value
    :value="shelfName"
    placeholder="请输入名称搜索"
    style="width: 100%"
    :filter-option="false"
    :dropdownMatchSelectWidth="false"
    :not-found-content="fetching ? undefined : null"
    @blur="blurSelect"
    @search="fetchUser"
    @change="handleChange"
    allowClear>
    <a-spin v-if="fetching" slot="notFoundContent" size="small" />
    <a-select-option v-for="item in data" :key="item.shelfSn" :value="item.shelfSn">{{ item.shelfName }}</a-select-option>
  </a-select>
</template>
<script>
import debounce from 'lodash/debounce'
import { shelfList } from '@/api/shelf'
export default {
  props: {
    itemSn: {
      type: String || Number,
      default: undefined
    }
  },
  data () {
    this.lastFetchId = 0
    this.fetchUser = debounce(this.fetchUser, 800)
    return {
      data: [],
      shelfName: undefined,
      fetching: false
    }
  },
  methods: {
    fetchUser (shelfName) {
      console.log('fetching user', shelfName)
      if (shelfName == '') return
      this.lastFetchId += 1
      const fetchId = this.lastFetchId
      this.data = []
      this.fetching = true
      shelfList({ shelfName: shelfName, pageNo: 1, pageSize: 20 }).then(res => {
        if (fetchId !== this.lastFetchId) {
          return
        }
        this.data = res.data && res.data.list ? res.data.list : []
        this.fetching = false
      })
    },
    handleChange (value) {
      if (value && value.key) {
        const ind = this.data.findIndex(item => item.shelfSn == value.key)
        value.row = ind != -1 ? this.data[ind] : undefined
      }
      Object.assign(this, {
        shelfName: value,
        data: [],
        fetching: false
      })
      this.$emit('change', value || { key: undefined, label: '' })
    },
    resetForm () {
      this.shelfName = undefined
    },
    setData (value) {
      Object.assign(this, {
        shelfName: value,
        data: [],
        fetching: false
      })
    },
    blurSelect () {
      this.data = []
    }
  },
  mounted () {
    if (this.itemSn) {
      this.fetchUser(this.itemSn)
      this.setData({ key: this.itemSn })
    }
  }
}
</script>
